TOOL_NAME = "Create Local Send"

--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME,
  invoke = function()main()end -- main_toggle()
}
--[
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:"..TOOL_NAME,
  invoke = function()main()end -- main_start()
}

--[[
renoise.tool():add_menu_entry {
  name = "Pattern Editor:"..TOOL_NAME,
  invoke = function()main()end -- main_start()
}

renoise.tool():add_menu_entry {
  name = "Mixer:"..TOOL_NAME,
  invoke = function()main()end -- main_start()
}

--]]
--[[
--With group
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME.." With Group",
  invoke = function()main(true)end -- main_toggle()
}
--]]

--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
local function status(message)
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end

--global so we only have to scan on first use of tool in each session
m_ratio_present = nil

-----------------------
function main(with_grp)
-----------------------
  --song properties
  local song = renoise.song()
  local cur_trk_idx = song.selected_track_index
  local cur_trk = song.selected_track
  
  --loop to make sure Mratio is present
  local num_devs = #cur_trk.available_devices 
  if m_ratio_present == nil then
    for i = 1,num_devs do
      if cur_trk.available_devices[i] == "Audio/Effects/VST/MRatio" then
        m_ratio_present = true
        break
      end
    end
  end
  
  --status if MRatio not found
  if m_ratio_present == nil then
    status("Tool Requires The MRatio Plugin To Work, It Can Be Downloaded From:    www.meldaproduction.com   ")
    return
  end
  
  --create local send as next track
  local loc_snd_trk = song:insert_track_at(cur_trk_idx+1)
  loc_snd_trk.name = "[LS]"
--loc_snd_trk.collapsed = true
  
  
  if m_ratio_present == true then --add and configure it
    --add MRatio VST
    local m_ratio = loc_snd_trk:insert_device_at("Audio/Effects/VST/MRatio", 2)
    --m_ratio.parameters[1].show_in_mixer = true  --show ratio control in mixer
    m_ratio.parameters[1].value = 1 --set ratio value in plug
    
    --insert sidechain device on current track
    local sc_dev = cur_trk:insert_device_at("Audio/Effects/Native/#Sidechain",#cur_trk.devices +1)
   
    --route sidechain device
    sc_dev.parameters[1].value = 0.55 --amount
    sc_dev.parameters[3].value = (cur_trk_idx) --route to new send track [LS]
    sc_dev.parameters[4].value = 1 --route to M Ratio
    sc_dev.display_name = "To [LS]"
--[[  
  else -- use a renoise gate and monitor the Envelope filter (phasey performance)
   
    local gate = loc_snd_trk:insert_device_at("Audio/Effects/Native/Gate 2", 2)
    gate.active_preset_data = <?xml version="1.0" encoding="UTF-8"?>
<FilterDevicePreset doc_version="13">
  <DeviceSlot type="Gate2Device">
    <IsMaximized>true</IsMaximized>
    <Threshold>
      <Value>-60</Value>
    </Threshold>
    <Attack>
      <Value>1.0</Value>
    </Attack>
    <Hold>
      <Value>0.0</Value>
    </Hold>
    <Release>
      <Value>5</Value>
    </Release>
    <Floor>
      <Value>0.0</Value>
    </Floor>
    <ListenToSideChain>true</ListenToSideChain>
    <SideChainHpFreq>
      <Value>0.0</Value>
    </SideChainHpFreq>
    <SideChainLpFreq>
      <Value>127</Value>
    </SideChainLpFreq>
    <Type>
      <Value>0.0</Value>
    </Type>
    <MixMode>
      <Value>1.0</Value>
    </MixMode>
  </DeviceSlot>
</FilterDevicePreset>


    --insert sidechain device on current track
    local sc_dev = cur_trk:insert_device_at("Audio/Effects/Native/#Sidechain",#cur_trk.devices +1)
    --route sidechain device
    sc_dev.parameters[1].value = 0.55 --amount
    sc_dev.parameters[3].value = (cur_trk_idx) --route to new send track [LS]
    sc_dev.parameters[4].value = 1 --route to M Ratio
    sc_dev.display_name = "To [LS]"
    
 --]]
 
  end
 
 --add group
 -- if with_grp == true then
 --   song:insert_group_at(index)
 -- end

end



--NOTES:
 
--sc params
-- print(sc_dev.parameters[1].name)  --amount
-- print(sc_dev.parameters[2].name)  --panning
-- print(sc_dev.parameters[3].name)  --dest track
-- print(sc_dev.parameters[4].name)  --dest effect





